///// Capacitor.java /////
/**
 * Class that emulate a capacitor conduct. Implements Serializable
 * @author Jesus Márquez Barrera
 */

import java.awt.*;

import java.io.*;

public class Capacitor extends ElectricalElement implements Serializable, Cloneable{
	public Object clone(){
		try{
			return (Capacitor) super.clone();
		}
		catch(CloneNotSupportedException e){
			return null;
		}
	}

	private static int id=0;
	private int topLeftX, topLeftY, width;
	private double capacitance, voltage, current;
	private CapacitorView view;
	private boolean selected;
	private boolean overwrite;

	public Capacitor(int tlx, int tly, int w){
		super(id++);
		capacitance=voltage=current=0;
		topLeftX=tlx;
		topLeftY=tly;
		width=w;
		view = new CapacitorView(this);
	}

	public double getCurrent(){
		return 0;
	/* I=C*dV/dt. Not used. to be implemented as future project*/
	}

	public double getDirection(){
		return dir;
	}

	public boolean getSelected(){
		return selected;
	}

	public double getVoltage(){
		return 0;
	/* V=1/C*integrate(Idt). Not used. to be implemented as future project*/
	}

	public int topLeftX(){
		return topLeftX;
	}

	public int topLeftY(){
		return topLeftY;
	}

	public int width(){
		return width;
	}

	public void paintView(Graphics2D g){
		view.draw(g);
	}
	
	public void resize(int tlx, int tly, int w){
		topLeftX=tlx;
		topLeftY=tly;
		width=w;		
	}
	
	public void setDirection(double d){
		dir=d;
	}

	public void setValue(double value){
		capacitance=value;
	}

	public void setSelected(boolean sel){
		selected = sel;
	}

	public boolean getOverWrite(){
		return overwrite;
	}

	public void setOverWrite(boolean overw){
		overwrite = overw;
	}
/*
	public void dragDelta(int dx, int dy){
	}*/
}