///// Inductor.java /////
/**
 * Class that emulate a inductor conduct. Implements Serializable
 * @author Jesus Márquez Barrera
 */

import java.awt.*;

import java.io.*;

public class Inductor extends ElectricalElement implements Serializable, Cloneable{
	public Object clone(){
		try{
			return (Inductor) super.clone();
		}
		catch(CloneNotSupportedException e){
			return null;
		}
	}
	
	private static int id=0;
	private int topLeftX, topLeftY, width;
	private double inductance, voltage, current;
	private InductorView view;

	public Inductor(int tlx, int tly, int w){
		super(id++);
		inductance=voltage=current=0;
		topLeftX=tlx;
		topLeftY=tly;
		width=w;
		view = new InductorView(this);
	}

	public double getCurrent(){
		return 0;
	/* I=1/C*integrate(VIdt). Not used. to be implemented as future project*/
	}

	public double getVoltage(){
		return 0;
	/* V=C*dI/dt. Not used. to be implemented as future project*/
	}

	public int topLeftX(){
		return topLeftX;
	}

	public int topLeftY(){
		return topLeftY;
	}

	public int width(){
		return width;
	}

	public void paintView(Graphics2D g){
		view.draw(g);
	}
	
	public void resize(int tlx, int tly, int w){
		topLeftX=tlx;
		topLeftY=tly;
		width=w;		
	}
	
	public void setValue(double value){
		inductance=value;
	}
}
