///// Resistor.java /////
/**
 * Class that emulate a resistor conduct. Implements Serializable
 * @author Jesus Márquez Barrera
 */

import java.awt.*;

import java.io.*;


public class Resistor extends ElectricalElement implements Serializable, Cloneable{
	public Object clone(){
		try{
			return (Resistor) super.clone();
		}
		catch(CloneNotSupportedException e){
			return null;
		}
	}
	
	private static int id=0;
	private int topLeftX, topLeftY, width;
	private double resistance, voltage, current;
	private ResistorView view;

	public Resistor(int tlx, int tly, int w){
		super(id++);
		resistance=voltage=current=0;
		topLeftX=tlx;
		topLeftY=tly;
		width=w;
		view = new ResistorView(this);
	}

	public double getCurrent(){
		return 0;
	/*I=V/R. Not used. to be implemented as future project*/
	}

	public double getVoltage(){
		return 0;
	/* V=R*I. Not used. to be implemented as future project*/
	}

	public int topLeftX(){
		return topLeftX;
	}

	public int topLeftY(){
		return topLeftY;
	}

	public int width(){
		return width;
	}

	public void paintView(Graphics2D g){
		view.draw(g);
	}
	
	public void resize(int tlx, int tly, int w){
		topLeftX=tlx;
		topLeftY=tly;
		width=w;		
	}

	public void setValue(double value){
		resistance=value;
	}

}
